#
#  controller.py
#  Erwinia
#
#  Created by Alex Rubin on 4/29/09.
#  Copyright (c) 2009 Alex Rubin. All rights reserved.
#

from objc import YES, NO, IBAction, IBOutlet
from Foundation import *
from AppKit import *
from PyObjCTools import AppHelper
import os
from os import path
from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer
from SocketServer import ThreadingMixIn
import threading
from threading import Thread
import socket
import urllib
import math

fileList = []
port = 8080
statusList = []

class ErwiniaHandler(BaseHTTPRequestHandler):
	def do_GET(self):
		global fileList
		global statusList
		if self.path == "/":
			self.send_response(200)
			self.send_header("Content-type", "text/html")
			self.end_headers()
			self.wfile.write("<strong>Files:</strong><br />")
			files = False
			for x in fileList:
				if x["type"] == "File":
					files = True
					if os.path.getsize(x["path"]) < (1024 * 1024):
						self.wfile.write("<a href=\"" + x["name"] + "\">" + x["name"] + "</a> (Size: " + str(int(os.path.getsize(x["path"]) / 1024.0)) + " KB)<br />")
					else:
						self.wfile.write("<a href=\"" + x["name"] + "\">" + x["name"] + "</a> (Size: " + str(int(os.path.getsize(x["path"]) / (1024.0 * 1024.0))) + " MB)<br />")
			if files is False:
				self.wfile.write("No files!<br />")
			folders = False
			self.wfile.write("<br /><strong>Folders:</strong><br />")
			for x in fileList:
				if x["type"] == "Folder":
					folders = True
					self.wfile.write("<a href=\"" + x["name"] + "\">" + x["name"] + "</a><br />")
			if folders is False:
				self.wfile.write("No folders!<br />")
			return
		else:
			for x in fileList:
				if urllib.unquote(self.path[1:]).split("/")[0] == x["name"]:
					if not os.path.exists(x["path"]):
						self.send_error(404, "File/folder not found")
						return
					if x["type"] == "File":
						size = os.path.getsize(x["path"])
						dict = NSMutableDictionary.dictionaryWithDictionary_({"address": self.client_address[0], "file": x["name"], "status": "Starting..."})
						statusList += [dict]
						pointer = statusList[statusList.index(dict)]
						NSApplication.sharedApplication().windows()[0].windowController().statusController.rearrangeObjects()
						self.send_response(200)
						self.send_header("Content-disposition", "attachment; name=" + x["name"])
						self.send_header("Content-length", size)
						self.end_headers()
						chunkSize = 0
						if size >= (1024 * 1024 * 100):
							chunkSize = 1024 * 1024
						elif size < (1024 * 1024 * 100) and size >= (1024 * 1024 * 10):
							chunkSize = 1024 * 512
						elif size < (1024 * 1024 * 10) and size >= (1024 * 1024):
							chunkSize = 1024 * 64
						else:
							chunkSize = 1024 * 8
						file = open(x["path"], "r")
						try:
							while True:
								chunk = file.read(chunkSize)
								if chunk == "":
									break
								else:
									self.wfile.write(chunk)
								pointer["status"] = str(int((file.tell() * 100) / size)) + "%"
						except:
							pass
						file.close()
						del statusList[statusList.index(pointer)]
						NSApplication.sharedApplication().windows()[0].windowController().statusController.rearrangeObjects()
						return
					else:
						folder = ""
						path = urllib.unquote(self.path[1:]).split("/")[1:]
						for dir in path:
							if dir == ".." or dir == "":
								self.send_error(403, "Invalid directory")
								return
							else:
								folder += "/" + dir
						folder = folder.rstrip("/")
						if not os.path.exists(x["path"] + folder):
							self.send_error(404, "File/folder not found")
							return
						if os.path.isfile(x["path"] + folder):
							size = os.path.getsize(x["path"] + folder)
							dict = NSMutableDictionary.dictionaryWithDictionary_({"address": self.client_address[0], "file": x["name"] + folder, "status": "Starting..."})
							statusList += [dict]
							pointer = statusList[statusList.index(dict)]
							NSApplication.sharedApplication().windows()[0].windowController().statusController.rearrangeObjects()
							self.send_response(200)
							self.send_header("Content-disposition", "attachment; name=" + os.path.basename(x["path"] + folder))
							self.send_header("Content-length", size)
							self.end_headers()
							chunkSize = 0
							if size >= (1024 * 1024 * 100):
								chunkSize = 1024 * 1024
							elif size < (1024 * 1024 * 100) and size >= (1024 * 1024 * 10):
								chunkSize = 1024 * 512
							elif size < (1024 * 1024 * 10) and size >= (1024 * 1024):
								chunkSize = 1024 * 64
							else:
								chunkSize = 1024 * 8
							file = open(x["path"] + folder, "rb")
							try:
								while True:
									chunk = file.read(chunkSize)
									if chunk == "":
										break
									else:
										self.wfile.write(chunk)
									pointer["status"] = str(int((file.tell() * 100) / size)) + "%"
							except:
								pass
							file.close()
							del statusList[statusList.index(pointer)]
							NSApplication.sharedApplication().windows()[0].windowController().statusController.rearrangeObjects()
							return
						else:
							self.send_response(200)
							self.end_headers()
							self.wfile.write("<strong>File listing for " + x["name"] + folder + ":</strong><br />")
							if not folder == "":
								self.wfile.write("<a href=\"/" + x["name"] + folder.rsplit("/", 1)[0] + "\">Go up a directory</a><br />")
							self.wfile.write("<a href=\"/\">Back to index</a><br /><br />")
							files = os.listdir(x["path"] + folder)
							if len(files) == 0:
								self.wfile.write("No files/folders!")
								return
							for file in files:
								if os.path.isfile(x["path"] + folder + "/" + file):
									if os.path.getsize(x["path"] + folder) < (1024 * 1024):
										self.wfile.write("<a href=\"/" + x["name"] + folder + "/" + file + "\">" + file + "</a> (Size: " + str(int(os.path.getsize(x["path"] + folder + "/" + file) / 1024.0)) + " KB)<br />")
									else:
										self.wfile.write("<a href=\"/" + x["name"] + folder + "/" + file + "\">" + file + "</a> (Size: " + str(int(os.path.getsize(x["path"] + folder + "/" + file) / (1024.0 * 1024.0))) + " MB)<br />")
								else:
									self.wfile.write("<a href=\"/" + x["name"] + folder + "/" + file + "\">" + file + "</a> (Directory)<br />")
							return
			self.send_error(404, "File/folder not found")
			return

class ThreadedHTTPServer(ThreadingMixIn, HTTPServer):
	pass

class MainServer(Thread):
	def __init__(self):
		Thread.__init__(self)
	def run(self):
		global port
		threadserver = ThreadedHTTPServer(("", port), ErwiniaHandler)
		threadserver.serve_forever()

class controller(NSWindowController):
	
	tableView = IBOutlet()
	arrayController = IBOutlet()
	statusView = IBOutlet()
	statusController = IBOutlet()
	global fileList
	hostedFiles = fileList
	global statusList
	statusArray = statusList
	directory = ""
	
	def awakeFromNib(self):
		self.directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0]
		server = MainServer()
		server.start()
		
	@IBAction
	def addButton_(self, sender):
		panel = NSOpenPanel.openPanel()
		panel.setCanChooseDirectories_(YES)
		panel.setAllowsMultipleSelection_(NO)
		panel.beginSheetForDirectory_file_modalForWindow_modalDelegate_didEndSelector_contextInfo_(self.directory, None, NSApp().mainWindow(), self, 'openPanelDidEnd:panel:returnCode:contextInfo:', 0)
	
	@AppHelper.endSheetMethod
	def openPanelDidEnd_panel_returnCode_contextInfo_(self, panel, returnCode, contextInfo):
		if returnCode:
			if os.path.isfile(panel.filenames()[0]):
				type = "File"
				self.directory = os.path.dirname(panel.filenames()[0])
			else:
				type = "Folder"
				self.directory = panel.filenames()[0]
			for x in self.hostedFiles:
				if x["name"] == os.path.basename(panel.filenames()[0]):
					alert = NSAlert.alloc().init()
					alert.setMessageText_("Duplicate file/folder")
					alert.setInformativeText_("There is already a file or folder with the name \"" + os.path.basename(panel.filenames()[0]) + "\"!")
					alert.setAlertStyle_(NSWarningAlertStyle)
					alert.runModal()
					return
			self.hostedFiles += [NSDictionary.dictionaryWithDictionary_({"name": os.path.basename(panel.filenames()[0]), "type": type, "url": "http://" + socket.gethostbyname(socket.gethostname()) + ":" + str(port) + "/" + os.path.basename(panel.filenames()[0]), "path": panel.filenames()[0]})]
			self.arrayController.rearrangeObjects()
		else:
			pass
	
	@IBAction
	def removeButton_(self, sender):
		if self.tableView.selectedRow() == -1:
			return
		del self.hostedFiles[self.tableView.selectedRow()]
		self.arrayController.rearrangeObjects()